Subject: Re: [PATCH net-next] net: phy: bcm84881: add BCM84891/BCM84892 support

From: "Russell King (Oracle)" <[email-masked]>
Date: Tue, 24 Mar 2026 20:01:48 +0000

On Tue, Mar 24, 2026 at 08:18:21PM +0100, Andrew Lunn wrote:
> > In that case let me drop LEDs from v2 for now. The hardware is a single
> > bicolor LED (green/amber) with speed-based color selection (vendor firmware
> > does 10G=green, else amber). I don't immediately see an obvious way to express
> > that in the LED framework. If there's a good example to follow I'd appreciate
> > a pointer; otherwise I'll figure it out as a follow-up.
> 
> That is why asked about its capabilities.
> 
> The minimum you need for /sys/class/leds is to be able to turn the LED
> on and off.
> 
> What sort of bicolor LED is it? 2 legs or three? Are green and amber
> mutually exclusive, or can you control them independently? If they are
> independent, then you can represent it as two LEDs. If the colours are
> mutually exclusive its a different story.
> 
> Oh, unusual, there is a datasheet:
> 
> https://datasheet4u.com/pdf/1561522/BCM84891L.pdf
> 
> That is not like Broadcom.

That looks like 0x4011 isn't documented on this PHY.

There's also a bunch of MDIO commands that can be used to enquire the
status of USXGMII enable/AN enable, and what mode is used for 2.5G
and 5G.

It also states:

XFI/10GBASE-KR, USXGMII, 5000BASE-X, 2500BASE-X, 5000BASE-R, 2500BASE-R,
and 1000BASE-X (SGMII) MAC Interface

5G rate over USXGMII/XFI/5000BASE-R/5000BASE-X MAC interface

2.5G rate over USXGMII/XFI/2500BASE-R/2500BASE-X MAC interface

It doesn't say when SGMII mode is used (assuming it does support SGMII,
section 1.11 makes it very vague what is actually going on there - I
think someone was having a game of ethernet protocol bingo, finding out
how many different ethernet protocols they can state one after each
other in a single sentence, while making the sentence meaningless!)

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTP is here! 80Mbps down 10Mbps up. Decent connectivity at last!